/*
 *  krt_symbols_sysctl.c,v 1.1 1993/04/29 19:45:07 jch Exp
 */

/* Gated Release 3.1 */
/* Copyright (c) 1990,1991,1992,1993 by Cornell University. All rights reserved. */
/* Refer to Particulars and other Copyright notices at the end of this file. */


#define	INCLUDE_UDP
#define	INCLUDE_UDP_VAR
#include "include.h"
#ifdef	PROTO_INET
#include "inet.h"
#endif	/* PROTO_INET */
#include "krt.h"
#include "krt_var.h"
#include <sys/sysctl.h>

int
krt_symbols __PF0(void)
{
    char buf[BUFSIZ];
    int name[CTL_MAXNAME];
    size_t len;

    name[0] = CTL_KERN;
    name[1] = KERN_VERSION;
    len = sizeof buf;
    if (sysctl(name, 2, buf, &len, (void *) 0, 0) < 0) {
	trace(TR_ALL, LOG_INFO,
	      "krt_symbols: sysctl(CTL_KERN, KERN_VERSION): %m");
    } else {
	/* Set version */
	
	krt_version_kernel = task_mem_strdup(krt_task, buf);
    }

#ifdef	PROTO_INET
    name[0] = CTL_NET;
    name[1] = AF_INET;

    name[2] = IPPROTO_IP;
    name[3] = IPCTL_FORWARDING;
    len = sizeof inet_ipforwarding;
    if (sysctl(name, 4, (void *) inet_ipforwarding, &len, (void *) 0, 0) < 0) {
	trace(TR_ALL, LOG_INFO,
	      "krt_symbols: sysctl(CTL_NET, AF_INET, IPPROTO_IP, IPCTL_FORWARDING): %m");
    }

    name[2] = IPPROTO_UDP;
    name[3] = UDPCTL_CHECKSUM;
    len = sizeof inet_udpcksum;
    if (sysctl(name, 4, (void *) inet_udpcksum, &len, (void *) 0, 0) < 0) {
	trace(TR_ALL, LOG_INFO,
	      "krt_symbols: sysctl(CTL_NET, AF_INET, IPPROTO_UDP, UDP_CHECKSUM): %m");
    }
#endif	/* PROTO_INET */
    
    trace(TR_KRT, 0, NULL);
    trace(TR_KRT, 0, "krt_symbols: krt_version_kernel = %s",
	  krt_version_kernel);

    return 0;
}
